;******************************************************************************
;CHBH.lsp  Fr AutoCAD 2000, 2000i, 2002, 2004, und 2005
;Bentigt: CHBH.dcl , HOCH.shx
;Umwandlung allgemeiner Mazahlen in ARCHITEKTURgerechte Mazahlen
;mm und 1/10mm knnen hochgestellt werden
;(C) Copyright Konstruktionsbro W. MEYER, D-85649 Otterloh,         10.05.2004
;******************************************************************************
(defun c:CHBH (/ aws n ent el en pp dx dr atxt fixatxt fixntxt ntxt alup 
                 azin me cmmm cm1 cm2 mm1 mm2 txtme txtcm txtmm dcl_id
                 o_str n_str o_slen n_slen si st k)
;------------------------------------------------------------------------------
 ;(command "_undo" "_m")(terpri)(terpri)
 (defun *error* (msg)
  (setvar "luprec" alup)(setvar "dimzin" azin);(setvar "dimdsep" asep)
  (setq aws nil n nil ent nil el nil en nil pp nil dx nil dr nil
        atxt nil ntxt nil fixatxt nil fixntxt nil alup nil azin nil 
        me nil cmmm nil cm1 nil cm2 nil mm1 nil mm2 nil 
        txtme nil txtcm nil txtmm nil dcl_id nil
        o_str nil n_str nil o_slen nil n_slen nil si nil st nil 
  )
  (princ msg) (princ)
 )
;------------------------------------------------------------------------------
 (setq alup (getvar "luprec"))
 (setq azin (getvar "dimzin"))
 (setq asep (getvar "dimdsep"))
 ;(setvar "dimdsep" ".")
 (setvar "cmdecho" 0)
;------------------------------------------------------------------------------
 (while (= AWS nil)(CHBWAHL) )
 (if (= TR 1)
  (progn
   (setq n (sslength AWS))
   (while (>= (setq n (1- n)) 0)
    (entmod (entget (ssname AWS n)))
   )
  )
  (progn					;progn 1
   (setq n (sslength AWS))			;Anzahl Elemente max.
   (while (>= (setq n (1- n)) 0)		;solange Anzahl noch >=0
    (setq ent (ssname AWS n))			;jedem Element einen Namen
    (setq fixel (entget (ssname AWS n)) )	;fixel wird fr Matextnderungen ber die Dialogbox bentigt
    (entmod (entget ent))			;wegen A12 Mae in A13 Zeichnung
    (setq el (entget ent))
    (setq el (tblsearch "BLOCK" (cdr (assoc 2 el))))
    (setq en (cdr (assoc -2 el)))
    (while en
     (setq el (entget en))
     (if (or (= "MTEXT" (cdr (assoc 0 el))) (= "TEXT" (cdr (assoc 0 el))) )
      (progn
       (setq pp (cdr (assoc 70 (entget ent))))
       (cond
        ((or (= pp  32)(= pp 160)(= pp  0)(= pp 128)	;LINEAR
             (= pp  33)(= pp 161)(= pp  1)(= pp 129)	;AUSGERICHTET
             (= pp  38)(= pp 166)(= pp  6)(= pp 134)	;X-ORDINATE
             (= pp 102)(= pp 230)(= pp 70)(= pp 198)	;Y-ORDINATE
             ;;;;(= pp 37)(= pp 165)(= pp 5)(= pp 133)	;WINKEL 3Punkt
             ;;;;(= pp 34)(= pp 162)(= pp 2)(= pp 130)	;WINKEL 
         )
         (if (= "MTEXT" (cdr (assoc 0 el)) )
          (setq DX (cdr (assoc 42 (entget ent))) en nil)
          (setq DX (cdr (assoc 1 el)) en nil)
         )
        )
        ((or (= pp 35)(= pp 163)(= pp 3)(= pp 131))	;DURCHMESSER
         (if (= "MTEXT" (cdr (assoc 0 el)) )
          (setq DR "%%c" DX (cdr (assoc 42 (entget ent))) en nil)
          (setq DR "%%c" DX (cdr (assoc 1 el)) en nil DX (substr DX 4))
         )
        )
        ((or (= pp 36)(= pp 164)(= pp 4)(= pp 132))	;RADIUS
         (if (= "MTEXT" (cdr (assoc 0 el)) )
          (setq DR "R=" DX (cdr (assoc 42 (entget ent))) en nil)
          (setq DR "R=" DX (cdr (assoc 1 el)) en nil DX (substr DX 2))
         )
        )
       )
      )
      (setq en (entnext en))
     )							;(if (or (= "MTEXT"
    )							;(while en
;Wenn keine saubere Mazahl, dann manuelle nderung------------------------
    (setq atxt (cdr (assoc 1 (entget ent))))		;= "" oder "Neutext-Ma"
    (if (= atxt "")
     (setq DX (rtos DX 2 4))
     (setq DX (cdr (assoc 1 (entget ent))))
    )
    (redraw ent 3)(redraw)(redraw ent 4)
    (if (= (wcmatch DX "[~.]*@*,[~,]*@*,*@*,*` *,*`-*,*`%*,*`**,*=*,*/*,*+*,**,**") T)
     (progn (setq ntxt atxt) (setq fixatxt ntxt) (CHBEDIT) (setq fixntxt ntxt) )
;Prfen AWS-Element, wenn Zeichen vorhanden - dann wird die Dialogbox aufgerufen
;  Im Font HOCH.shx ist =Alt241 , Hochstellen =Alt190
;* Entspricht jeder Zeichenfolge incl. Leerschlag
;@ Entspricht jedem alphabetischen Einzelzeichen, [~X=]*@* verneint X=* 
;, Das Komma trennt zwei Muster
;` Das nchste Zeichen wird wrtlich gelesen, - nicht als von-bis interpretiert
;? Entspricht jedem Einzelzeichen
;  Abbruch wenn vorh.: A-Z Leerzeichen - % * = / +  

;------------------------------------------------------------------------------
     (progn						;progn2
      (setvar "luprec" MZ)				;3- oder 4-Nachkommastellen
      (setvar "dimzin" 0)				;0.0000 Ja
;Beginn: suche nach Komma ersetze durch Punkt
      (setq o_str ",")(setq n_str ".")
      (setq o_slen (strlen o_str))
      (setq n_slen (strlen n_str))
      (setq si 1)
      (while (= o_slen (strlen (setq st (substr DX si o_slen))))
       (if (= st o_str)
        (progn
         (setq DX (strcat
                   (if (> si 1) (substr DX 1 (1- si)) "" )
                   n_str (substr DX (+ si o_slen))
         )        )
         (setq si (+ si n_slen))
        )
        (setq si (1+ si))
       )
      )
;Ende: suche nach Komma ersetze durch Punkt
      (setq DX (atof DX))				;"12.3456" ergibt 12.3456
      (setq DX (/ DX MX))				;=12.3456  m
      (setq me (float (fix DX)))			;=12.0000  m
      (setq cmmm (- DX me))				;=0.3456   m
      (setq me (rtos me 2 0))				;"12"      m
      (setq cmmm (rtos cmmm 2  MZ))			;"0.3456"  m
      (setq cm1 (substr cmmm 3 1))			;="3"      cm1
      (setq cm2 (substr cmmm 4 1))			;="4"      cm2
      (setq mm1 (substr cmmm 5 1))			;="5"      mm1
      (setq mm2 (substr cmmm 6 1))			;="6"      mm2
;METER
      (if (>= (read me) 1)
;------------------------------------
;nach Meter ein Komma
       (setq txtme (strcat me ","))			;"12,"     m,
;------------------------------------
;nach Meter ein Punkt
       ;(setq txtme (strcat me "."))			;"12."     m.
;------------------------------------
       (setq txtme "")					;""        nichts
      )
;ZENTIMETER
      (if (> (read cm1) 0)
       (setq txtcm (strcat cm1 cm2))			;"34"      cm
       (setq txtcm cm2)					;"4"       cm
      )
      (if (>= (read me) 1)
       (setq txtcm (strcat cm1 cm2))			;"34"      cm
      )
      (if (and (< (read me) 1) (= (read cm1) 0) (= (read cm2) 0)
               (or (> (read mm1) 0) (> (read mm2) 0) )
          )
       (setq txtcm "0")					;"0"       cm
      )

;MILLIMETER
;------------------------------------------------------
;2-Stellige mm mit Komma
      (if (= MZ 4) (setq k ",") (setq k "" mm2 "" ) )
;------------------------------------------------------
;2-Stellige mm mit Punkt
      ;(if (= MZ 4) (setq k ".") (setq k "" mm2 "" ) )
;------------------------------------------------------
;2-Stellige mm ohne Komma/Punkt
      ;(if (= MZ 4) (setq k "") (setq k "" mm2 "" ) )
;------------------------------------------------------
      (if (= (read mm2) 0) (setq k "" mm2 "" ) )
      (if (= MZ 4)
       (setq txtmm (strcat mm1 k mm2))			;"5.6"     mm 2-Stellig
       (setq txtmm mm1)					;"5"       mm 1-Stellig
      )
      (if (and (or (= (read mm1) 0)(= mm1 "")) (or (= (read mm2) 0)(= mm2 "")) )
       (setq txtmm "")					;""        nichts
      )
;Zusammenstellung der ARCHITEKTUR-Zahl
      (if (not DR)
       (if (= "MTEXT" (cdr (assoc 0 el)))
;-----------------------------------------------------------------------------
;Hochzahl mit Abstand zur Zahl 
        ;(setq ntxt (strcat txtme txtcm " \\H0.7x;\\A1;\\S"""txtmm";"))
;------------------------------------------------------------------------------
;C2 = Hochzahl in gelb 
        ;(setq ntxt (strcat txtme txtcm "\\C2;""\\H0.7x;\\A1;\\S"""txtmm";"))
;------------------------------------------------------------------------------
;Hochzahl ohne Farbzuweisung 
        (setq ntxt (strcat txtme txtcm "\\H0.7x;\\A1;\\S"""txtmm";"))
;------------------------------------------------------------------------------
        (setq ntxt (strcat txtme txtcm "" txtmm))		; = Alt190
       )
       (if (= "MTEXT" (cdr (assoc 0 el)))
;------------------------------------------------------------------------------
;Hochzahl mit Abstand zur Zahl
        ;(setq ntxt (strcat DR txtme txtcm " \\H0.7x;\\A1;\\S"""txtmm";"))
;------------------------------------------------------------------------------
;C2 = Hochzahl in gelb
        ;(setq ntxt (strcat DR txtme txtcm "\\C2;""\\H0.7x;\\A1;\\S"""txtmm";"))
;------------------------------------------------------------------------------
;Hochzahl ohne Farbzuweisung
        (setq ntxt (strcat DR txtme txtcm "\\H0.7x;\\A1;\\S"""txtmm";"))
;------------------------------------------------------------------------------
        (setq ntxt (strcat DR txtme txtcm "" txtmm))		; = Alt190
       )
      )
     )							;progn2
;------------------------------------------------------------------------------
    )							;(if (and (/= atxt
    (if (/= fixatxt fixntxt)				;ist Matext ber Dialogbox gendert worden
     (setq el (entget (cdr (assoc -1 fixel))))		;dann ist die nderung fix
    )							;sonst bleibt das Ma assoziativ
    (setq el (subst (cons 1 ntxt)(assoc 1 el) el))
    (entmod el)
    (entupd ent)
    (setq ntxt nil atxt nil DR nil fixatxt nil fixntxt nil)
   )							;end (while (>= (setq n
  )							;end progn 1
 )							;end (if (= TR 1)
 (setvar "luprec" alup)
 (setvar "dimzin" azin)
 ;(setvar "dimdsep" asep)
 (princ "\n\nDie Umwandlung der Mazahlen wurde ausgefhrt.")
 (princ)
)							;end defun
;******************************************************************************
(defun CHBWAHL ()
 (if (= setok nil)(IFOK) )
 (princ "\nFr nderung der Voreinstellungen - Return ")
 (princ "\nFr nderung der Mazahlen die ")
 (setq AWS (ssget (list (cons -4 "<and")
                        (cons  0 "DIMENSION")
                        (cons -4 "<not")(cons 70  34)(cons -4 "not>")
                        (cons -4 "<not")(cons 70 162)(cons -4 "not>")
                        (cons -4 "<not")(cons 70   2)(cons -4 "not>")
                        (cons -4 "<not")(cons 70 130)(cons -4 "not>")
                        (cons -4 "<not")(cons 70  37)(cons -4 "not>")
                        (cons -4 "<not")(cons 70 165)(cons -4 "not>")
                        (cons -4 "<not")(cons 70   5)(cons -4 "not>")
                        (cons -4 "<not")(cons 70 133)(cons -4 "not>")
                        (cons -4 "and>")
 )         )      )
 (if (= AWS nil)(IFOK) )
 (princ "\n\nDie Mazahlen werden umgewandelt...\n")
 (princ)
)
;******************************************************************************
(defun IFOK ()
 (while (/= setok 1)
  (CHBSET)
  (if
   (or (and (or (=  XME 1)(=  XCM 1)(=  XMM 1)) (or (=  ZM 1)(=  ZMM 1)) )
       (and (or (/= XME 1)(/= XCM 1)(/= XMM 1)) (or (/= ZM 1)(/= ZMM 1))
            (= TR 1)
       )
   )
   (setq setok 1)
  )
 )
 (setq setok 0)
 (princ)
)
;******************************************************************************
(defun M-XME ()
 (set_tile "MXCM" "0")(set_tile "MXMM" "0")(set_tile "MTR" "0")
 (setq XCM nil XMM nil TR nil)
 (princ)
)
;------------------------------------------------------------------------------
(defun M-XCM ()
 (set_tile "MXMM" "0")(set_tile "MXME" "0")(set_tile "MTR" "0")
 (setq XMM nil XME nil TR nil)
 (princ)
)
;------------------------------------------------------------------------------
(defun M-XMM ()
 (set_tile "MXCM" "0")(set_tile "MXME" "0")(set_tile "MTR" "0")
 (setq XCM nil XME nil TR nil)
 (princ)
)
;------------------------------------------------------------------------------
(defun M-ZM ()
 (set_tile "MZMM" "0")(set_tile "MTR" "0")
 (setq ZMM nil TR nil)
 (princ)
)
;------------------------------------------------------------------------------
(defun M-ZMM ()
 (set_tile "MZM" "0")(set_tile "MTR" "0")
 (setq ZM nil TR nil)
 (princ)
)
;------------------------------------------------------------------------------
(defun M-TR ()
 (set_tile "MXME" "0")(set_tile "MXCM" "0")(set_tile "MXMM" "0")
 (set_tile "MZM"  "0")(set_tile "MZMM" "0")
 (setq XME nil XCM nil XMM nil ZM nil ZMM nil)
 (princ)
)
;******************************************************************************
(defun CHBSET (/ dcl_id)
 (setq dcl_id (load_dialog "CHBH.DCL"))
 (if (not (new_dialog "CHBSET" dcl_id)) (exit) )
;Keyfestlegungen---------------------------------------
;Vorgaben----------------------------------------------
 (set_tile "MXME" (if (= XME 1) "1" "0"))
 (set_tile "MXCM" (if (= XCM 1) "1" "0"))
 (set_tile "MXMM" (if (= XMM 1) "1" "0"))
 (set_tile "MZM"  (if (= ZM  1) "1" "0"))
 (set_tile "MZMM" (if (= ZMM 1) "1" "0"))
 (set_tile "MTR"  (if (= TR  1) "1" "0"))
;Ausfhrungen------------------------------------------
 (action_tile "MXME" "(M-XME)(setq XME (atoi $value))")
 (action_tile "MXCM" "(M-XCM)(setq XCM (atoi $value))")
 (action_tile "MXMM" "(M-XMM)(setq XMM (atoi $value))")
 (action_tile "MZM"  "(M-ZM) (setq ZM  (atoi $value))")
 (action_tile "MZMM" "(M-ZMM)(setq ZMM (atoi $value))")
 (action_tile "MTR"  "(M-TR) (setq TR  (atoi $value))")
 (action_tile "accept" "(done_dialog)")
 (action_tile "cancel" "(done_dialog)(exit)")
 (start_dialog)
 (unload_dialog dcl_id)
 (cond ((= XME 1)(setq MX 1.0))
       ((= XCM 1)(setq MX 100.0))
       ((= XMM 1)(setq MX 1000.0))
 )
 (cond ((= ZM  1)(setq MZ 3))
       ((= ZMM 1)(setq MZ 4))
 )
 (cond ((= TR  1)(setq MT 1)) )
 (princ)
)
;******************************************************************************
(defun CHBEDIT (/ dcl_id)
 (if(/= (wcmatch DX "*\\S#;*") T)
  (progn
   (progn
    (setq dcl_id (load_dialog "CHBH.DCL"))
    (if (not (new_dialog "CHBEDIT" dcl_id)) (exit) )
;Keyfestlegungen------------------------------------
;Vorgaben-------------------------------------------
    (set_tile "TEMPTXT" ntxt)
;Ausfhrungen---------------------------------------
    (action_tile "TEMPTXT" "(setq ntxt $value)")
    (action_tile "accept"  "(done_dialog)")
    (action_tile "cancel"  "(setq ntxt atxt) (done_dialog)")
    (action_tile "info" "(INFO1)")
    (start_dialog)
    (unload_dialog dcl_id)
   )
  )
 )
 (princ)
)
;******************************************************************************
(defun INFO1 (/ )
(alert "
\Automatisch umgewandelte und mit \\S**;
\hndisch hochgestellte Matexte sind
\MicroStation kompatibel.
\die mit Alt190 nicht."
)
(princ)
)
;******************************************************************************
(princ"\nUmwandlung allgemeiner Mazahlen in ARCHITEKTURgerechte Mazahlen.")
(princ"\nDie Ursprungsschreibweise bleibt erhalten.  Starten mit CHBH ")
(princ)
;******************************************************************************
